/*
  Test_KY-036.ino
  Il programma comanda alternativamente l'accensione di un led
  di diverso colore (rosso e verde) contenuto in un led RGB.
  Il valore rilevato analogico rilevato dal sensore viene
  mostrato sul plotter seriale.
  il segnale proveniente dal pin digitale può essere ascoltato
  tramite il buzzer.

  Sono utilizzati i seguenti pin
  Pin +5V           -> Alimentazione +5V
  Pin GND           -> GND
  Pin Digital 8     -> Out digitale modulo KY-036
  Pin Digital 9     -> Led Verde
  Pin Digital 10    -> led Rosso
  Pin Digital 11    -> buzzer
  Pin Analogico A0  -> Out analogico modulo KY-036

  Creato il 5/3/2017 da Adriano Gandolfo
  Sito web http://www.adrirobot.it
  Blog http://it.emcelettronica.com/author/adrirobot
  Pagina Facebook https://www.facebook.com/Adrirobot-318949048122955
  Istagram https://www.instagram.com/adrirobot/
  This example code is in the public domain.
*/


// Definizione dei pin del modulo KY-036
int pin_A0 = A0;
int touchPin = 8;
// Definizione dei pin del modulo KY-016
int led_G = 10;
int led_R = 9;
// Definizione dei pin del modulo KY-006
int buzzer = 12;

// Memorizza il tempo in cui l'ultimo evento accaduto
unsigned long lastEvent = 0;

// Memorizzare lo stato del LED
boolean led_G_ON = false;
boolean led_R_ON = false;

// Memorizza il valore letto dal sensore
int valore_A0 = 0;

void setup() {
  // Impostazione porta seriale
  Serial.begin(9600);
  // setup pins
  pinMode(touchPin, INPUT);
  pinMode(led_G, OUTPUT);
  pinMode(led_R, OUTPUT);
  pinMode(buzzer, OUTPUT);
  // imposta lo stato iniziale dei led
  digitalWrite(led_G, HIGH);
  digitalWrite(led_R, LOW);
}

void loop() {
  //Lettura valore analogico e invio
  //a plotter seriale
  valore_A0 = analogRead(pin_A0);
  Serial.println(valore_A0);
  // Lettuara dello stato del sensore a sfioramento
  int touchState = digitalRead(touchPin);
  // Nel caso sia HIGH
  if (touchState == HIGH) {
    digitalWrite(buzzer, HIGH);
    digitalWrite(buzzer, LOW);
    // Se sono passati 50ms da l'ultimo impulso HIGH
    if (millis() - lastEvent > 50) {
      //commuta i led in uscita
      led_G_ON = !led_G_ON;
      digitalWrite(led_G, led_G_ON ? HIGH : LOW);
      digitalWrite(led_R, led_R_ON ? LOW : HIGH);
    }
    // Ricorda quando l'ultimo evento accaduto
    lastEvent = millis();
  }
}
